## ntfs2btrfs 20210923

=== CMakeLists.txt ===
if(MSVC)
    cmake_minimum_required(VERSION 3.15)
    cmake_policy(SET CMP0091 NEW)
else()
    cmake_minimum_required(VERSION 3.14.3)
endif()

project(ntfs2btrfs VERSION 20210923)

include(GNUInstallDirs)

option(WITH_ZLIB "Include zlib support" ON)
option(WITH_LZO "Include lzo support" ON)
option(WITH_ZSTD "Include zstd support" ON)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ntfs2btrfs.8.in ${CMAKE_CURRENT_BINARY_DIR}/ntfs2btrfs.8)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(fmt REQUIRED)
find_package(PkgConfig REQUIRED)

if(WITH_ZLIB)
    find_package(ZLIB REQUIRED)
endif()

if(WITH_LZO)
    pkg_check_modules(LZO REQUIRED lzo2)
endif()

if(WITH_ZSTD)
    pkg_check_modules(ZSTD REQUIRED libzstd)
endif()

set(SRC_FILES src/ntfs2btrfs.cpp
    src/ntfs.cpp
    src/decomp.cpp
    src/compress.cpp
    src/rollback.cpp
    src/crc32c.c
    src/xxhash.c
    src/sha256.c
    src/blake2b-ref.c
    src/ebiggers/lzx_decompress.c
    src/ebiggers/lzx_common.c
    src/ebiggers/aligned_malloc.c
    src/ebiggers/decompress_common.c
    src/ebiggers/xpress_decompress.c)

if(MSVC)
    enable_language(ASM_MASM)
    set(SRC_FILES ${SRC_FILES} src/crc32c-masm.asm)
else()
    enable_language(ASM)
    set(SRC_FILES ${SRC_FILES} src/crc32c-gas.S)
endif()

add_executable(ntfs2btrfs ${SRC_FILES})
set_property(TARGET ntfs2btrfs PROPERTY
    MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")

target_link_libraries(ntfs2btrfs fmt::fmt-header-only)

if(WITH_ZLIB)
    target_link_libraries(ntfs2btrfs ZLIB::ZLIB)
endif()

if(WITH_LZO)
    target_link_libraries(ntfs2btrfs ${LZO_LINK_LIBRARIES})
endif()

if(WITH_ZSTD)
    target_link_libraries(ntfs2btrfs ${ZSTD_LINK_LIBRARIES})
endif()

include_directories(${CMAKE_CURRENT_BINARY_DIR})

# Work around bug in MSVC version of cmake - see https://gitlab.kitware.com/cmake/cmake/-/merge_requests/4257
set(CMAKE_ASM_MASM_COMPILE_OPTIONS_MSVC_RUNTIME_LIBRARY_MultiThreaded         "")
set(CMAKE_ASM_MASM_COMPILE_OPTIONS_MSVC_RUNTIME_LIBRARY_MultiThreadedDLL      "")
set(CMAKE_ASM_MASM_COMPILE_OPTIONS_MSVC_RUNTIME_LIBRARY_MultiThreadedDebug    "")
set(CMAKE_ASM_MASM_COMPILE_OPTIONS_MSVC_RUNTIME_LIBRARY_MultiThreadedDebugDLL "")

if(MSVC)
    target_compile_options(ntfs2btrfs PRIVATE /W4)
else()
    target_compile_options(ntfs2btrfs PRIVATE -Wall -Wextra -Wno-address-of-packed-member -Wconversion -Wno-unknown-pragmas -Werror=pointer-arith)
endif()

install(TARGETS ntfs2btrfs DESTINATION sbin)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ntfs2btrfs.8 DESTINATION ${CMAKE_INSTALL_MANDIR}/man8)

=== debian/changelog ===
ntfs2btrfs (20210923-2) unstable; urgency=medium

  * d/control: add missing pkg-config, liblzo2-dev, libzstd-dev, and zlib1g-dev
    to build-depends.

 -- Gürkan Myczko <tar@debian.org>  Tue, 16 Nov 2021 09:18:58 +0100

ntfs2btrfs (20210923-1) unstable; urgency=medium

  * New upstream version.
  * d/control:
    - add Vcs fields.
    - update maintainer address.

 -- Gürkan Myczko <tar@debian.org>  Mon, 15 Nov 2021 21:04:36 +0100

ntfs2btrfs (20210523-1) unstable; urgency=medium
 
  * Initial release. (Closes: #993939)
 
 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 08 Sep 2021 12:07:45 +0200

=== debian/control ===
Source: ntfs2btrfs
Section: utils
Priority: optional
Maintainer: Gürkan Myczko <tar@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, libfmt-dev, pkg-config, zlib1g-dev, liblzo2-dev, libzstd-dev
Standards-Version: 4.6.0
Homepage: https://github.com/maharmstone/ntfs2btrfs
Vcs-Browser: https://salsa.debian.org/debian/ntfs2btrfs
Vcs-Git: https://salsa.debian.org/debian/ntfs2btrfs.git
Rules-Requires-Root: no

Package: ntfs2btrfs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: btrfs-progs
Description: converts NTFS filesystem to BTRFS
 This is a tool which does in-place conversion of Microsoft's NTFS filesystem
 to the open-source filesystem Btrfs, much as btrfs-convert does for ext2.
 The original image is saved as a reflink copy at image/ntfs.img, and if you
 want to keep the conversion you can delete this to free up space.

## ntfs2btrfs 20220812

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,9 @@
-if(MSVC)
-    cmake_minimum_required(VERSION 3.15)
-    cmake_policy(SET CMP0091 NEW)
-else()
-    cmake_minimum_required(VERSION 3.14.3)
-endif()
+cmake_minimum_required(VERSION 3.14.3)
 
-project(ntfs2btrfs VERSION 20210923)
+cmake_policy(SET CMP0091 NEW)
+set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
+
+project(ntfs2btrfs VERSION 20220812)
 
 include(GNUInstallDirs)
 
@@ -16,7 +14,7 @@
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ntfs2btrfs.8.in ${CMAKE_CURRENT_BINARY_DIR}/ntfs2btrfs.8)
 
-set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD 20)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 find_package(fmt REQUIRED)
@@ -58,8 +56,10 @@
 endif()
 
 add_executable(ntfs2btrfs ${SRC_FILES})
-set_property(TARGET ntfs2btrfs PROPERTY
-    MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
+
+if(CMAKE_BUILD_TYPE MATCHES "Debug")
+    add_definitions(-D_GLIBCXX_DEBUG)
+endif()
 
 target_link_libraries(ntfs2btrfs fmt::fmt-header-only)
 
@@ -89,5 +89,5 @@
     target_compile_options(ntfs2btrfs PRIVATE -Wall -Wextra -Wno-address-of-packed-member -Wconversion -Wno-unknown-pragmas -Werror=pointer-arith)
 endif()
 
-install(TARGETS ntfs2btrfs DESTINATION sbin)
+install(TARGETS ntfs2btrfs DESTINATION ${CMAKE_INSTALL_SBINDIR})
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ntfs2btrfs.8 DESTINATION ${CMAKE_INSTALL_MANDIR}/man8)

=== debian/changelog ===
ntfs2btrfs (20220812-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version to 4.6.1.
  * d/copyright: bump years.

 -- Gürkan Myczko <tar@debian.org>  Mon, 15 Aug 2022 12:49:02 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Gürkan Myczko <tar@debian.org>
 Build-Depends: debhelper-compat (= 13), cmake, libfmt-dev, pkg-config, zlib1g-dev, liblzo2-dev, libzstd-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/maharmstone/ntfs2btrfs
 Vcs-Browser: https://salsa.debian.org/debian/ntfs2btrfs
 Vcs-Git: https://salsa.debian.org/debian/ntfs2btrfs.git

## ntfs2btrfs 20230501

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 cmake_policy(SET CMP0091 NEW)
 set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
 
-project(ntfs2btrfs VERSION 20220812)
+project(ntfs2btrfs VERSION 20230501)
 
 include(GNUInstallDirs)

=== debian/changelog ===
ntfs2btrfs (20230501-2) unstable; urgency=medium

  * Upload to unstable.

 -- Gürkan Myczko <tar@debian.org>  Sun, 11 Jun 2023 16:14:59 +0200

ntfs2btrfs (20230501-1) experimental; urgency=medium

  * New upstream version.
  * d/copyright: bump years.
  * Bump standards version to 4.6.2.

 -- Gürkan Myczko <tar@debian.org>  Wed, 03 May 2023 23:04:58 +0200

## ntfs2btrfs 20240115

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 cmake_policy(SET CMP0091 NEW)
 set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
 
-project(ntfs2btrfs VERSION 20230501)
+project(ntfs2btrfs VERSION 20240115)
 
 include(GNUInstallDirs)

=== debian/changelog ===
ntfs2btrfs (20240115-2) unstable; urgency=medium

  * Bump standards version to 4.7.0.
  * d/control: update build depends pkg-config to pkgconf.

 -- Alex Myczko <tar@debian.org>  Mon, 15 Jul 2024 06:19:47 +0000

ntfs2btrfs (20240115-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright: bump years.

 -- Gürkan Myczko <tar@debian.org>  Mon, 22 Jan 2024 08:24:28 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,15 @@
 Source: ntfs2btrfs
 Section: utils
 Priority: optional
-Maintainer: Gürkan Myczko <tar@debian.org>
-Build-Depends: debhelper-compat (= 13), cmake, libfmt-dev, pkg-config, zlib1g-dev, liblzo2-dev, libzstd-dev
-Standards-Version: 4.6.1
+Maintainer: Alex Myczko <tar@debian.org>
+Build-Depends: debhelper-compat (= 13),
+ cmake,
+ pkgconf,
+ libfmt-dev,
+ liblzo2-dev,
+ libzstd-dev,
+ zlib1g-dev,
+Standards-Version: 4.7.0
 Homepage: https://github.com/maharmstone/ntfs2btrfs
 Vcs-Browser: https://salsa.debian.org/debian/ntfs2btrfs
 Vcs-Git: https://salsa.debian.org/debian/ntfs2btrfs.git

## ntfs2btrfs 20250616

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 cmake_policy(SET CMP0091 NEW)
 set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
 
-project(ntfs2btrfs VERSION 20240115)
+project(ntfs2btrfs VERSION 20250616)
 
 include(GNUInstallDirs)

=== debian/changelog ===
ntfs2btrfs (20250616-2) unstable; urgency=medium

  * Upload to sid.

 -- Alex Myczko <tar@debian.org>  Fri, 05 Sep 2025 10:38:13 -0500

ntfs2btrfs (20250616-1) experimental; urgency=medium

  * New upstream version.
  * Bump standards version to 4.7.2.

 -- Alex Myczko <tar@debian.org>  Mon, 07 Jul 2025 09:35:54 +0000

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  liblzo2-dev,
  libzstd-dev,
  zlib1g-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/maharmstone/ntfs2btrfs
 Vcs-Browser: https://salsa.debian.org/debian/ntfs2btrfs
 Vcs-Git: https://salsa.debian.org/debian/ntfs2btrfs.git

=== debian/watch ===
version=4

# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%$1.tar.gz%" \
   https://github.com/maharmstone/ntfs2btrfs/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
